﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Linq;
using System.Data;
using System.Reflection;
public partial class CS : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        //List collection with some data.
        List<Customer> customers = new List<Customer>();
        customers.Add(new Customer { CustomerId = 1, Name = "John Hammond", Country = "United States" });
        customers.Add(new Customer { CustomerId = 2, Name = "Mudassar Khan", Country = "India" });
        customers.Add(new Customer { CustomerId = 3, Name = "Suzzane Mathews", Country = "France" });
        customers.Add(new Customer { CustomerId = 4, Name = "Robert Schidner", Country = "Russia" });

        //Linq query.
        var query = from customer in customers
                    select customer;

        DataTable dt = LinqToDataTable<Customer>(query);
    }

    //Generic function to convert Linq query to DataTable.
    public DataTable LinqToDataTable<T>(IEnumerable<T> items)
    {
        //Createa DataTable with the Name of the Class i.e. Customer class.
        DataTable dt = new DataTable(typeof(T).Name);

        //Read all the properties of the Class i.e. Customer class.
        PropertyInfo[] propInfos = typeof(T).GetProperties(BindingFlags.Public | BindingFlags.Instance);

        //Loop through each property of the Class i.e. Customer class.
        foreach (PropertyInfo propInfo in propInfos)
        {
            //Add Columns in DataTable based on Property Name and Type.
            dt.Columns.Add(new DataColumn(propInfo.Name, propInfo.PropertyType));
        }

        //Loop through the items if the Collection.
        foreach (T item in items)
        {
            //Add a new Row to DataTable.
            DataRow dr = dt.Rows.Add();

            //Loop through each property of the Class i.e. Customer class.
            foreach (PropertyInfo propInfo in propInfos)
            {
                //Add value Column to the DataRow.
                dr[propInfo.Name] = propInfo.GetValue(item, null);
            }
        }

        return dt;
    }

    public class Customer
    {
        public int CustomerId { get; set; }
        public string Name { get; set; }
        public string Country { get; set; }
    }
}