﻿Imports System.Linq
Imports System.Data
Imports System.Reflection

Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        'List collection with some data.
        Dim customers As List(Of Customer) = New List(Of Customer)()
        customers.Add(New Customer With {.CustomerId = 1, .Name = "John Hammond", .Country = "United States"})
        customers.Add(New Customer With {.CustomerId = 2, .Name = "Mudassar Khan", .Country = "India"})
        customers.Add(New Customer With {.CustomerId = 3, .Name = "Suzzane Mathews", .Country = "France"})
        customers.Add(New Customer With {.CustomerId = 4, .Name = "Robert Schidner", .Country = "Russia"})

        'Linq query.
        Dim query = From customer In customers
                    Select customer

        Dim dt As DataTable = LinqToDataTable(Of Customer)(query)
    End Sub

    'Generic function to convert Linq query to DataTable.
    Public Function LinqToDataTable(Of T)(ByVal items As IEnumerable(Of T)) As DataTable
        'Createa DataTable with the Name of the Class i.e. Customer class.
        Dim dt As DataTable = New DataTable(GetType(T).Name)

        'Read all the properties of the Class i.e. Customer class.
        Dim propInfos As PropertyInfo() = GetType(T).GetProperties(BindingFlags.Public Or BindingFlags.Instance)

        'Loop through each property of the Class i.e. Customer class.
        For Each propInfo As PropertyInfo In propInfos
            'Add Columns in DataTable based on Property Name and Type.
            dt.Columns.Add(New DataColumn(propInfo.Name, propInfo.PropertyType))
        Next

        'Loop through the items of the Collection.
        For Each item As T In items
            'Add a new Row to DataTable.
            Dim dr As DataRow = dt.Rows.Add()

            'Loop through each property of the Class i.e. Customer class.
            For Each propInfo As PropertyInfo In propInfos
                'Add value Column to the DataRow.
                dr(propInfo.Name) = propInfo.GetValue(item, Nothing)
            Next
        Next

        Return dt
    End Function

    Public Class Customer
        Public Property CustomerId As Integer
        Public Property Name As String
        Public Property Country As String
    End Class
End Class
